#include "CivHydrCompute.h"
#include "CivTypes.h"

CivHydrCompute::CivHydrCompute(char* inp, char* rptFile, char* binFile)
    :mInpFile(inp),mRptFile(rptFile),mBinFile(binFile)
{

}

bool CivHydrCompute::qualityCompute()
{
    // ˮҪȽˮ,ûֱӲENSolveH Ϊ˿Ǽѹѹ
    long  t(0), tstep(0);
    int   iTime(0);

    int  errcode = 0;
    errcode = ENopen(mInpFile, mRptFile, mBinFile);
    if (errcode > 0)
    {
        ENclose();
        return false;
    }

    if (ENopenH() > 0)
    {
        ENclose();
        return false;
    }

    if (ENinitH(EN_SAVE) > 0)
    {
        ENclose();
        return false;
    }


    do
    {
        int nLinkCount;
        ENgetcount(EN_LINKCOUNT, &nLinkCount);
        /*for (int i = 1; i <= nLinkCount; i++)
        {
            int linkType;
            char id[128] = "";
            ENgetlinktype(i, &linkType);
            ENgetlinkid(i, id);
        }*/

        errcode = ENrunH(&t);	// errcode > 100 Ǵ
        if (errcode > 100)
        {
            ENcloseH();
            ENclose();
            return false;
        }

        ENnextH(&tstep);
        iTime++;

        // ȡǰڵ͹ܶ
        getNodeResult(iTime);
        getLinkResult(iTime);

    } while (tstep > 0);

    ENcloseH();

    // ˮʷ
    ENopenQ();
    ENinitQ(1);

    t = 0;
    tstep = 0;
    iTime = 0;
    do
    {
        errcode = ENrunQ(&t);	// errcode > 100 Ǵ
        if (errcode > 100)
        {
            ENcloseQ();
            ENclose();
            return false;
        }

        // ȡˮģ
        getNodeQuality(iTime);
        getLinkQuality(iTime);

        ENstepQ(&tstep);

        iTime++;

    } while (tstep > 0);


    ENcloseQ();
    ENclose();
	return true;
}

bool CivHydrCompute::hdyrCompute()
{
    short hydCode = 1;
    long  t(0), tstep(0);
    int   iTime(0);

    int  errcode = 0;

    errcode = ENopen(mInpFile, mRptFile, mBinFile);
    if (errcode > 0)
    {
        ENclose();
        return false;
    }
    
    if (ENopenH() > 0)
    {
        ENclose();
        return false;
    }

    if (ENinitH(0) > 0)
    {
        ENclose();
        return false;
    }
    float dHStep;
    ENGetVal(4, &dHStep);
    do
    {
        int nLinkCount;
        ENgetcount(EN_LINKCOUNT, &nLinkCount);
        /*for (int i = 1; i <= nLinkCount; i++)
        {
            int linkType;
            char id[128] = "";
            ENgetlinktype(i, &linkType);
            ENgetlinkid(i, id);
        }*/

        if (ENrunH(&t) > 100)	// errcode > 100 Ǵ
        {
            ENclose();
            return false;
        }

        ENnextH(&tstep);

        // ȡǰڵ͹ܶ
        getNodeResult(iTime);
        getLinkResult(iTime);
        iTime++;
    } while (tstep > 0);

    ENcloseH();
    ENclose();

    return true;
}

void CivHydrCompute::getNodeResult(short time)
{

    // ڵ
    int nNodeCount;
    ENgetcount(EN_NODECOUNT, &nNodeCount);
    int* typeCode = (int*)malloc(sizeof(int));

    for (int i = 1; i <= nNodeCount; i++)
    {     
        ENgetlinktype(i, typeCode);
        if (*typeCode == EN_TANK || *typeCode== EN_RESERVOIR)
        {
            continue;
        }
        
        NodeResultItem nodeItem;
        // 
        ENgetnodeid(i, nodeItem.szNo);
      
        // ˮͷ
        ENgetnodevalue(i, EN_HEAD, &nodeItem.dHead);
        // ѹ
        ENgetnodevalue(i, EN_PRESSURE, &nodeItem.dPressure);
        // 
        ENgetnodevalue(i, EN_ELEVATION, &nodeItem.dElevation);
        // ʵˮ
        ENgetnodevalue(i, EN_DEMAND, &nodeItem.dDemand);

       
        // ˮ
        ENgetnodevalue(i, EN_TANKVOLUME, &nodeItem.dTankVolume);
        // ˮ
        ENgetnodevalue(i, EN_MAXVOLUME, &nodeItem.dTankMaxVolume);
        // Һλ߶
        ENgetnodevalue(i, EN_TANKLEVEL, &nodeItem.dTankLevel);

        nodeItem.dInterval = time;

        // ŵ 
        //mResultCache.addNodeItems(nodeItem);
    }
    free(typeCode);

    // ˮ
    int tankCount;
}

void CivHydrCompute::getLinkResult(short time)
{
    int  nLinkCount;
    ENgetcount(EN_LINKCOUNT, &nLinkCount);

    for (int i = 1; i <= nLinkCount; i++)
    {
        LinkResultItem linkItem;

        int* typeCode = (int*)malloc(sizeof(int));

        ENgetlinktype(i, typeCode);
        if (*typeCode != EN_PIPE)
        {
            free(typeCode);
            continue;
        }
        free(typeCode);

        // 
        ENgetlinkid(i, linkItem.szNo);
        //  
        ENgetlinkvalue(i, EN_FLOW, &linkItem.dFlow);
        // 
        linkItem.nFlowDirect = (linkItem.dFlow >= 0) ? 0 : 1;
        // 
        ENgetlinkvalue(i, EN_VELOCITY, &linkItem.dVelocity);
        // ˮͷʧ
        ENgetlinkvalue(i, EN_HEADLOSS, &linkItem.dHeadloss);
       
        // ״̬
        float fState = 0;
        ENgetlinkvalue(i, EN_STATUS, &fState);
        if ((int)fState == 0)
            strcpy_s(linkItem.szStatus, "ر");
        else
            strcpy_s(linkItem.szStatus, "");

        linkItem.dInterval = time;
        // ŵ 
        // mResultCache.addLinkItems(linkItem);
    }


}

void CivHydrCompute::getNodeQuality(short time)
{
    int nNodeCount;
    ENgetcount(EN_NODECOUNT, &nNodeCount);

    float* quality = (float*)malloc(sizeof(float));
    for (int i = 1; i <= nNodeCount; i++)
    {
        char No[35];
        // 
        ENgetnodeid(i, No);
        // ˮ
        ENgetnodevalue(i, EN_QUALITY, quality);

        // mResultCache.addNodeQuality(*quality, time, No);
    }
    free(quality);
}

void CivHydrCompute::getLinkQuality(short time)
{
    int  nLinkCount;
    ENgetcount(EN_LINKCOUNT, &nLinkCount);
    int* typeCode = (int*)malloc(sizeof(int));
    for (int i = 1; i <= nLinkCount; i++)
    {
        if (*typeCode != EN_PIPE)
            continue;

        ENgetlinktype(i, typeCode);
        
        char lnkNo[35];
        // 
        ENgetlinkid(i, lnkNo);

        float quality;
        // ˮ
        ENgetlinkvalue(i, EN_LINKQUAL, &quality);
    }
    free(typeCode);
}